if (Drupal.jsEnabled) {
  $(window).load(webfmImagesGetMenusAjax);
}

webfmImages = new Object();

webfmImages.ajaxUrl = function() {
  var path = getBaseUrl() + "/?q=";
  return path += (typeof getModUrl == "undefined") ? "webfm_images_js" : getModUrl();
}


function webfmImagesGetMenusAjax() {
  var menus = '';
  var url = webfmImages.ajaxUrl();
  var postObj = { action:"get resize menu items", filepath:''};
  Webfm.HTTPPost(url, webfmImageExtender, menus, postObj);
  return false;
}

//
function webfmImageExtender(menus){

  menus=Drupal.parseJson(menus);
  var arLen=menus.length;
  for ( var i=0, len=arLen; i<len; ++i ){
    //WebfmImages.menus = menus[i];
    Webfm.menu.put('file', new Webfm.menuElement("Resize to "+menus[i], webfmImagesResize, webfmImagesTest));
  }

  Webfm.menu.put('file', new Webfm.menuElement('Preview image', webfmImagesPreview, webfmImagesTest));

}

webfmImagesTest = function(obj){

  switch(obj.ext.toLowerCase()){
    case 'jpg':
    case 'jpeg':
    case 'png':
    case 'bmp':
    case 'gif':
      return true;
    default:
      return false;
  }

}

webfmImagesResize = function(obj){

  var url = webfmImages.ajaxUrl();
  var path = obj.element.title;
  var postObj = { action:this.desc, filepath:encodeURIComponent(path)};
  Webfm.HTTPPost(url, webfmImageResizeResult, obj, postObj);
  return false;

}

webfmImageResizeResult = function(response){


  Webfm.dirListObj.refresh(Webfm.dirListObj.content.current);
  Webfm.alrtObj.msg();
  Webfm.alrtObj.msg(response);


}

webfmImagesPreview = function (obj) {

//the call to this callback passes in obj
//obj is passed around - but it is the Webfm.dirrow or Webfm.filerow
//filerow has the following (hence obj has the following):
//obj.iconDir - the directory to icons -
//obj.dd - a webfm drag and drop method -
//obj.ext - the file extention
//obj.filepath - the path to the file (from drupal baseurl) e.g. /files/webfm/filename.ext
//obj.element > object HTMLTableRowElement
//  in theory we could add styles or attributes to it here
    //obj.element.style.background = 'pink';
//obj.element.id is set
//obj.element.title is set
//obj.element.className is set
//
//Webfm.dbgObj.dbg("obj ext:", obj.ext);
//Webfm.dbgObj.dbg("obj filepath:", obj.filepath);
//
//Webfm.dbgObj.dbg("obj element:", obj.element);
//Webfm.dbgObj.dbg("obj element - ID:", obj.element.id);
//Webfm.dbgObj.dbg("obj element - className:", obj.element.className);
//Webfm.dbgObj.dbg("obj element - Title:", obj.element.title);
//
//Webfm.dbgObj.dbg("obj element - TD?", obj.element.td);
//
//
//Webfm.dbgObj.dbg("obj dd_enable:", obj.dd_enable);
//Webfm.dbgObj.dbg("obj cxt_enable:", obj.cxt_enable);
//Webfm.dbgObj.dbg("obj menu:", obj.menu);


  var url = webfmImages.ajaxUrl();
  obj.is_file = ((obj.element.className != 'dirrow') && (obj.element.className.substring(0,4) != 'tree'));
  var path = obj.element.title;

    Webfm.progressObj.show(Webfm.js_msg["work"],  "blue");
    var postObj = { action:"preview image", filepath:encodeURIComponent(path)};

 //  Webfm.dbgObj.dbg("asdf:", obj);
    Webfm.HTTPPost(url, webfmImagePreviewDisplay, obj, postObj);
    Webfm.progressObj.hide();
    return false;

}

function removeChildrenFromNode(node){
  if(node !== undefined && node !== null){
    var len = node.childNodes.length;
      while (node.hasChildNodes()){
        node.removeChild(node.firstChild);
      }
    }
    return;
}

webfmImagePreviewDisplay = function (response) {
  var elDiv;
  if(!(elDiv = document.getElementById('preview-image'))){
    var elDiv = Webfm.ce('div');
    elDiv.setAttribute('id', 'preview-image');
  }
  else{
    removeChildrenFromNode(elDiv);
  }

  var elImg = Webfm.ce('img');
  elImg.setAttribute('src', response);

  elDiv.appendChild(elImg);
  if(!(elDivWebfm = this.layoutDiv)){
    elDivWebfm = document.getElementById('webfm');
  }
  elDivWebfm.appendChild(elDiv);
  return false;
}

